import rcDevTree
import glob
import os

class DevTree(rcDevTree.DevTree):
    def get_size(self, devpath):
        size = 0
        with open(devpath+'/size', 'r') as f:
            try:
                size = int(f.read().strip()) * 512 / 1024 / 1024
            except:
                pass
        return size

    def load(self):
        devpaths = glob.glob("/sys/block/*")
        devnames = map(lambda x: os.path.basename(x), devpaths)
        for devname, devpath in zip(devnames, devpaths):
             size = self.get_size(devpath)
             d = self.add_dev(devname, size)
             slavepaths = glob.glob("%s/slaves/*"%devpath)
             slavenames = map(lambda x: os.path.basename(x), slavepaths)
             for slavename, slavepath in zip(slavenames, slavepaths):
                 size = self.get_size(slavepath)
                 d.add_child(slavename, size)

if __name__ == "__main__":
    tree = DevTree()
    tree.load()
    print tree

